#!/bin/sh
# $Id: chromium-widevine-plugin.SlackBuild,v 1.11 2015/04/30 17:38:51 root Exp root $
# Copyright 2014, 2015  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         chromium-widevine-plugin
# Descr:       Google Chrome's Pepper Widevine plugin for Chromium
# URL:         http://www.google.com/chrome
# Build needs: 
# Needs:       
# Changelog:   
# 1.4.4.637-1: 31/aug/2014 by Eric Hameleers <alien@slackware.com>
#              * Initial release.
# 39.0.2171.95-1:
#              01/jan/2015 by Eric Hameleers <alien@slackware.com>
#              * Update and switch to using the chromium version.
# 40.0.2214.91-1:
#              22/jan/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 40.0.2214.111-1:
#              06/feb/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 41.0.2272.76-1:
#              06/mar/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 41.0.2272.101-1:
#              21/mar/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 41.0.2272.118-1:
#              02/apr/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 42.0.2311.90-1:
#              15/apr/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 42.0.2311.135-1:
#              30/apr/2015 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 
# Run 'sh chromium-widevine-plugin.SlackBuild' to build a Slackware package.
# The package (.txz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

# The version of this package will be determined later by examining the
# extracted library file.

PRGNAM=chromium-widevine-plugin
BUILD=${BUILD:-1}
TAG=${TAG:-alien}

# What is the Chrome version we extract this from?
# Version of the plugin as reported by the browser is determined in the
# chromium package. Check "chrome://plugins"
VERSION=${VERSION:-"42.0.2311.135"}
RPMCHAN=${RPMCHAN:-"stable"}
RPMSUB=${RPMSUB:-"-1"}

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

DOCS="$SRCDIR/license.html"

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

# Automatically determine the architecture we're building on:
MARCH=${ARCH:-$( uname -m )}
case "$MARCH" in
  x86_64)
    LIBDIRSUFFIX="64"
    ARCHBITS="64"
    export ARCH=x86_64
    ;;
  i?86)
    LIBDIRSUFFIX=""
    ARCHBITS="32"
    export ARCH=i386
    ;;
  *)
    echo "Unsupported architecture '$ARCH'"
    exit 1
    ;;
esac

SOURCE[0]="$SRCDIR/google-chrome-$RPMCHAN-$VERSION$RPMSUB.$ARCH.rpm"
SRCURL[0]="https://dl.google.com/linux/chrome/rpm/stable/$ARCH/google-chrome-$RPMCHAN-$VERSION$RPMSUB.$ARCH.rpm"

SOURCE[1]="$SRCDIR/license.html"
SRCURL[1]="http://www.google.com/chrome/intl/en/eula_text.html"

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
rpm2cpio ${SOURCE[0]} | cpio -dimv -R root:root \
  ./opt/google/chrome/libwidevinecdm.so
chmod -R u+w,go+r-w,a+X-s .

echo "++"
echo "Packaging $PRGNAM for chromium $VERSION"
echo "++"

# Move the extracted files over to the package location:
install -d  $PKG/usr/lib${LIBDIRSUFFIX}/chromium
install -m0755 opt/google/chrome/libwidevine* \
  $PKG/usr/lib${LIBDIRSUFFIX}/chromium/

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required
cat $SRCDIR/doinst.sh | sed -e "s/@PRGNAM@/${PRGNAM}/g" \
  > $PKG/install/doinst.sh

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

